Index: palm/trunk/SOURCE/chem_emissions_mod.f90
===================================================================
--- palm/trunk/SOURCE/chem_emissions_mod.f90	(revision 3610)
+++ palm/trunk/SOURCE/chem_emissions_mod.f90	(revision 3611)
@@ -658,63 +582,63 @@
 
              message_string = 'Array of Emission species not allocated: '            //          &
-                              ' Either no emission species are provided as input or'  //          &
-                              ' no chemical species are used by PALM:'                //          &
-                              ' Chemistry Emissions routine is not called'                                   
+                              ' Either no emission species are provided as input or'  //         &
+                              ' no chemical species are used by PALM:'                //         &
+                              ' Emission routine is not called'                                   
              CALL message( 'chem_emissions_matching', 'CM0441', 0, 2, 0, 6, 0 ) 
  
           ENDIF
-
-!-- CASE parameterized: In the parameterized case the user gives in input the exact species names of the chemical mechanism: no split is required for NOx, SOx, PMs and VOCs, but units of emissions inputs must be in (mole/m**)/s, made exception for PMs. 
-
+ 
+       !
+       !-- PARAMETERIZED mode
        CASE ("PARAMETERIZED")
 
-          len_index=0
-
-         !spc_names have to be greater than zero for proceeding
-          IF ( (SIZE(spc_names) .GT. 0) .AND. (nspec_emis_inp .GT. 0) ) THEN
-
-
-             !cycle over model species
-             DO ind_mod = 1, SIZE(spc_names)
-                ind_inp=1
-                DO  WHILE ( TRIM( surface_csflux_name( ind_inp ) ) /= 'novalue' )   !<'novalue' is the default  
-                   IF (TRIM(surface_csflux_name( ind_inp ))==TRIM(spc_names(ind_mod))) THEN
-                      len_index=len_index+1
+          len_index = 0
+
+          IF ( nvar > 0 .AND. nspec_emis_inp > 0 )  THEN
+
+             !
+             !-- Cycle over model species
+             DO ind_mod = 1, nvar
+                ind_inp = 1
+                DO WHILE ( TRIM( surface_csflux_name(ind_inp) ) /= 'novalue' )    !< 'novalue' is the default  
+                   IF ( TRIM( surface_csflux_name(ind_inp) ) == TRIM( spc_names(ind_mod) ) )  THEN
+                      len_index = len_index + 1
                    ENDIF
-                   ind_inp=ind_inp+1
-
+                   ind_inp = ind_inp + 1
                 ENDDO
              ENDDO
 
-             !Proceed only if there are matched species
-             IF ( len_index .GT. 0 ) THEN
-
-                !Allocation of Arrays of the matched species
-                ALLOCATE(match_spec_input(len_index)) 
- 
-                ALLOCATE(match_spec_model(len_index))
-
-                !Assign corresponding indices of input and model matched species
-                len_index=0
-
-                DO ind_mod = 1, SIZE(spc_names)  
+             IF ( len_index > 0 )  THEN
+
+                !
+                !-- Allocation of Arrays of the matched species
+                ALLOCATE( match_spec_input(len_index) ) 
+ 
+                ALLOCATE( match_spec_model(len_index) )
+
+                !
+                !-- Pass the species indices to declared arrays    
+                len_index = 0
+
+                DO ind_mod = 1, nvar  
                    ind_inp = 1
-                   DO  WHILE ( TRIM( surface_csflux_name( ind_inp ) ) /= 'novalue' )   !<'novalue' is the default  
-                      IF (TRIM( surface_csflux_name( ind_inp ) ) == TRIM(spc_names(ind_mod)))           THEN
-                         len_index=len_index+1
-                         match_spec_input(len_index)=ind_inp
-                         match_spec_model(len_index)=ind_mod
+                   DO WHILE ( TRIM( surface_csflux_name(ind_inp) ) /= 'novalue' )     
+                      IF ( TRIM( surface_csflux_name(ind_inp) ) == TRIM( spc_names(ind_mod) ) )  THEN
+                         len_index = len_index + 1
+                         match_spec_input(len_index) = ind_inp
+                         match_spec_model(len_index) = ind_mod
                       ENDIF
-                   ind_inp=ind_inp+1
+                   ind_inp = ind_inp + 1
                    END DO
                 END DO
 
-                ! also, Add AN if to check that when the surface_csflux are passed to the namelist, also the street factor values are provided
-                DO  ispec = 1 , len_index
-
-                   IF ( emiss_factor_main(match_spec_input(ispec)) .LT. 0 .AND. &
-                        emiss_factor_side(match_spec_input(ispec)) .LT. 0 ) THEN
-
-                      message_string = 'PARAMETERIZED emissions mode selected:'            //          &
+                !
+                !-- Check
+                DO ispec = 1, len_index
+
+                   IF ( emiss_factor_main(match_spec_input(ispec) ) < 0 .AND.    &
+                        emiss_factor_side(match_spec_input(ispec) ) < 0 )  THEN
+
+                      message_string = 'PARAMETERIZED emissions mode selected:'            //           &
                                        ' EMISSIONS POSSIBLE ONLY ON STREET SURFACES'        //          &
                                        ' but values of scaling factors for street types'    //          &
@@ -730,8 +654,8 @@
              ELSE
                 
-                message_string = 'Given Chemistry Emission Species'            //          &
-                                 ' DO NOT MATCH'                                //          &
-                                 ' model chemical species'                      //          &
-                                 ' Chemistry Emissions routine is not called'         
+                message_string = 'Non of given Emission Species'            //          &
+                                 ' matches'                                //           &
+                                 ' model chemical species'                 //           &
+                                 ' Emission routine is not called'         
                 CALL message( 'chem_emissions_matching', 'CM0443', 0, 0, 0, 6, 0 ) 
              ENDIF
@@ -739,8 +663,8 @@
           ELSE
      
-             message_string = 'Array of Emission species not allocated: '            //          &
+             message_string = 'Array of Emission species not allocated: '            //           &
                               ' Either no emission species are provided as input or'  //          &
                               ' no chemical species are used by PALM.'                //          &
-                              ' Chemistry Emissions routine is not called'                                   
+                              ' Emission routine is not called'                                   
              CALL message( 'chem_emissions_matching', 'CM0444', 0, 2, 0, 6, 0 ) 
  
@@ -748,8 +672,9 @@
 
 
-!-- CASE when emission module is switched on but mode_emis is not specified or it is given the wrong name
+       !
+       !-- If emission module is switched on but mode_emis is not specified or it is given the wrong name
        CASE DEFAULT
 
-          message_string = 'Chemistry Emissions Module switched ON, but'            //          &
+          message_string = 'Emission Module switched ON, but'            //                         &
                            ' either no emission mode specified or incorrectly given :'  //          &
                            ' please, pass the correct value to the namelist parameter "mode_emis"'                  
@@ -758,118 +683,117 @@
        END SELECT
 
-END SUBROUTINE chem_emissions_match
-
+ END SUBROUTINE chem_emissions_match
+
+ 
 !------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Initialization:
-!> Netcdf reading, arrays allocation and first calculation of cssws fluxes at timestep 0
-!>  
+!> Netcdf reading, arrays allocation and first calculation of cssws
+!> fluxes at timestep 0 
 !------------------------------------------------------------------------------!
- SUBROUTINE chem_emissions_init(emt_att,emt,nspec_out)
+ SUBROUTINE chem_emissions_init( emt_att, emt, nspec_out )
 
     USE surface_mod,                                                           &
-       ONLY:  surf_lsm_h,surf_def_h,surf_usm_h
+        ONLY:  surf_def_h, surf_lsm_h, surf_usm_h
     
     IMPLICIT NONE
  
-    TYPE(chem_emis_att_type),INTENT(INOUT)                            :: emt_att   !> variable where to store all the information of 
-                                                                                   !  emission inputs whose values do not depend
-                                                                                   !  on the considered species
-
-    TYPE(chem_emis_val_type),INTENT(INOUT), ALLOCATABLE, DIMENSION(:) ::  emt      !> variable where to store emission inputs values, 
-                                                                                   !  depending on the considered species
+    CHARACTER (LEN=80)          ::  units                                           !< units of inputs
     
-    INTEGER(iwp),INTENT(INOUT)                                        :: nspec_out !> number of outputs of chemistry emission routines
-
-    CHARACTER (LEN=80)                                                :: units     !> units of chemistry inputs
- 
-    INTEGER(iwp)                                                      :: ispec     !> Index to go through the emission chemical species
-
-
-!-- Actions for initial runs : TBD: needs to be updated
-  IF (  TRIM( initializing_actions ) /= 'read_restart_data' )  THEN
+    INTEGER(iwp), INTENT(INOUT) ::  nspec_out                                       !< number of outputs
+
+    INTEGER(iwp)                :: ispec                                            !< running index
+
+    TYPE(chem_emis_att_type), INTENT(INOUT) ::  emt_att                             !< variable where to store all the information
+                                                                                    !< of emission inputs whose values do not 
+                                                                                    !< depend on the considered species
+
+    TYPE(chem_emis_val_type), INTENT(INOUT), ALLOCATABLE, DIMENSION(:) ::  emt      !< variable where to store emission input  
+                                                                                    !< values depending on the considered species
+
+!    
+!-- Actions for initial runs 
+!  IF (  TRIM( initializing_actions ) /= 'read_restart_data' )  THEN
 !--    ... 
-    
+!    
 !
 !-- Actions for restart runs
+!  ELSE
+!--    ...
+!
+!  ENDIF
+
+
+  CALL location_message( 'Starting initialization of emission arrays', .FALSE. )
+
+  !
+  !-- Matching
+  CALL  chem_emissions_match( emt_att, nspec_out )
+ 
+  IF ( nspec_out == 0 )  THEN
+  
+     emission_output_required = .FALSE.
+
   ELSE
-!--    ...
-
-  ENDIF
-
-
-  CALL location_message( 'Starting initialization of chemistry emissions arrays', .FALSE. )
-
-
-  !-- Match Input and Model emissions
-  CALL  chem_emissions_match(emt_att,nspec_out)
-
-  !> If nspec_out==0, then do not use emission module: The corresponding message is already printed in the matching routine 
-  IF ( nspec_out == 0 ) THEN
-  
-     emission_output_required=.FALSE.
-
-  ELSE
-
-     emission_output_required=.TRUE.
-
-
-!-----------------------------------------------------------------
-     !> Set molecule masses' 
-     ALLOCATE(emt_att%xm(nspec_out))
-     ! loop over emisisons:
+
+     emission_output_required = .TRUE.
+
+
+     !
+     !-- Set molecule masses' 
+     ALLOCATE( emt_att%xm(nspec_out) )
 
      DO ispec = 1, nspec_out
-       ! switch:
-        SELECT CASE ( TRIM(spc_names(match_spec_model(ispec))) )
-           CASE ( 'SO2','SO4' ) ; emt_att%xm(ispec) = xm_S + xm_O * 2      ! kg/mole
-           CASE ( 'NO','NO2' )  ; emt_att%xm(ispec) = xm_N + xm_O * 2      ! kg/mole  NO2 equivalent
-           CASE ( 'NH3' ) ; emt_att%xm(ispec) = xm_N + xm_H * 3  ! kg/mole
-           CASE ( 'CO'  ) ; emt_att%xm(ispec) = xm_C + xm_O      ! kg/mole
-           CASE ( 'CO2' ) ; emt_att%xm(ispec) = xm_C + xm_O * 2  ! kg/mole
-           CASE ( 'CH4' ) ; emt_att%xm(ispec) = xm_C + xm_H * 4  ! kg/mole     
-           CASE ( 'HNO3' ); emt_att%xm(ispec) = xm_H + xm_N + xm_O*3 !kg/mole  
+        SELECT CASE ( TRIM( spc_names(match_spec_model(ispec)) ) )
+           CASE ( 'SO2' ); emt_att%xm(ispec) = xm_S + xm_O * 2        !< kg/mole
+           CASE ( 'SO4' ); emt_att%xm(ispec) = xm_S + xm_O * 4        !< kg/mole
+           CASE ( 'NO' ); emt_att%xm(ispec) = xm_N + xm_O             !< kg/mole
+           CASE ( 'NO2' ); emt_att%xm(ispec) = xm_N + xm_O * 2        !< kg/mole   
+           CASE ( 'NH3' ); emt_att%xm(ispec) = xm_N + xm_H * 3        !< kg/mole
+           CASE ( 'CO'  ); emt_att%xm(ispec) = xm_C + xm_O            !< kg/mole
+           CASE ( 'CO2' ); emt_att%xm(ispec) = xm_C + xm_O * 2        !< kg/mole
+           CASE ( 'CH4' ); emt_att%xm(ispec) = xm_C + xm_H * 4        !< kg/mole     
+           CASE ( 'HNO3' ); emt_att%xm(ispec) = xm_H + xm_N + xm_O*3  !< kg/mole  
            CASE DEFAULT
-             !--  TBD: check if this hase to be removed
-              !emt_att%xm(ispec) = 1.0_wp
+              emt_att%xm(ispec) = 1.0_wp
         END SELECT
      ENDDO
 
     
-     !> ASSIGN EMISSION VALUES for the different emission modes
-     SELECT CASE(TRIM(mode_emis))   !TBD: Add the option for CApital or small letters 
-
-
-        !> PRE-PROCESSED case
-        CASE ("PRE-PROCESSED")
-
-           IF ( .NOT. ALLOCATED( emis_distribution) ) ALLOCATE(emis_distribution(nzb:nzt+1,0:ny,0:nx,nspec_out))  
-
-           CALL location_message( 'emis_distribution array allocated in PRE-PROCESSED mode', .FALSE. )
- 
-           !> Calculate the values of the emissions at the first time step
-           CALL chem_emissions_setup(emt_att,emt,nspec_out)
-
-        !> Default case
-        CASE ("DEFAULT")
-
-           IF ( .NOT. ALLOCATED( emis_distribution) ) ALLOCATE( emis_distribution( 1, 0:ny, 0:nx, nspec_out ) ) 
-        
-           CALL location_message( 'emis_distribution array allocated in DEFAULT mode', .FALSE. )
-
-           !> Calculate the values of the emissions at the first time step
-           CALL chem_emissions_setup(emt_att,emt,nspec_out)
-
-        !> PARAMETERIZED case
-        CASE ("PARAMETERIZED")
-
-           CALL location_message( 'emis_distribution array allocated in PARAMETERIZED mode', .FALSE. )
-
-           ! For now for PAR and DEF values only, first vertical level of emis_distribution is allocated, while for PRE-PROCESSED all. 
-           IF ( .NOT. ALLOCATED( emis_distribution) ) ALLOCATE(emis_distribution(1,0:ny,0:nx,nspec_out))
-
-           !> Calculate the values of the emissions at the first time step
-           CALL chem_emissions_setup(emt_att,emt,nspec_out)
+     !
+     !-- assign emission values
+     SELECT CASE ( TRIM( mode_emis ) )   
+
+
+        !
+        !-- PRE-PROCESSED case
+        CASE ( "PRE-PROCESSED" )
+
+           IF ( .NOT. ALLOCATED( emis_distribution) ) ALLOCATE( emis_distribution(nzb:nzt+1,0:ny,0:nx,nspec_out) )  
+ 
+           !
+           !-- Get emissions at the first time step
+           CALL chem_emissions_setup( emt_att, emt, nspec_out )
+
+        !
+        !-- Default case
+        CASE ( "DEFAULT" )
+
+           IF ( .NOT. ALLOCATED( emis_distribution) ) ALLOCATE( emis_distribution(1,0:ny,0:nx,nspec_out) ) 
+
+           !
+           !-- Get emissions at the first time step
+           CALL chem_emissions_setup( emt_att, emt, nspec_out )
+
+        !
+        !-- PARAMETERIZED case
+        CASE ( "PARAMETERIZED" )
+
+           IF ( .NOT. ALLOCATED( emis_distribution) ) ALLOCATE( emis_distribution(1,0:ny,0:nx,nspec_out) )
+
+           !
+           !-- Get emissions at the first time step
+           CALL chem_emissions_setup( emt_att, emt, nspec_out)
 
      END SELECT
@@ -887,99 +811,78 @@
 !-------------------------------------------------------------------------------!
 
- SUBROUTINE chem_emissions_setup(emt_att,emt,nspec_out)
+ SUBROUTINE chem_emissions_setup( emt_att, emt, nspec_out )
 
    USE arrays_3d,                                                    &
        ONLY:  dzw
-   USE grid_variables,                                                        &
+   USE grid_variables,                                               &
        ONLY: dx, dy
-   USE indices,                                                               &
-       ONLY: nnx,nny,nnz 
-   USE surface_mod,                                                           &
-       ONLY:  surf_lsm_h,surf_def_h,surf_usm_h
-   USE netcdf_data_input_mod,                                                 &
+   USE indices,                                                      &
+       ONLY: nnx, nny, nnz 
+   USE surface_mod,                                                  &
+       ONLY:  surf_def_h, surf_lsm_h, surf_usm_h
+   USE netcdf_data_input_mod,                                        &
        ONLY:  street_type_f
-   USE arrays_3d,                                                             &        
+   USE arrays_3d,                                                    &        
        ONLY: hyp, pt 
 
+   
  IMPLICIT NONE
   
-    !--- IN/OUT
-
-    TYPE(chem_emis_att_type),INTENT(INOUT)                            ::  emt_att    !> variable where to store all the information of 
-                                                                                     !  emission inputs whose values do not depend
-                                                                                     !  on the considered species
-
-    TYPE(chem_emis_val_type),INTENT(INOUT), ALLOCATABLE, DIMENSION(:) ::  emt        !> variable where to store emission inputs values, 
-                                                                                     !  depending on the considered species
-
-    INTEGER,INTENT(IN)                                                ::  nspec_out  !> Output of routine chem_emis_matching with number
-                                                                                     !  of matched species
-    !---
-
-    REAL(wp),ALLOCATABLE,DIMENSION(:,:)                               ::  delta_emis !> Term to add to the emission_distribution array 
-                                                                                     !  for each of the categories at each time step 
-                                                                                     !  in the default mode
-
-    CHARACTER(LEN=80)                                                 ::  units      !> Units of the emissions
-
-    INTEGER(iwp)                                                      ::  icat       !> Index for number of categories
-    INTEGER(iwp)                                                      ::  ispec      !> index for number of species
-    INTEGER(iwp)                                                      ::  i_pm_comp  !> index for number of PM components
-    INTEGER(iwp)                                                      ::  ivoc       !> Index for number of components of  VOCs
-    INTEGER(iwp)                                                      ::  time_index !> Index for time
+
+    TYPE(chem_emis_att_type), INTENT(INOUT) ::  emt_att                         !< variable to store emission information                                                                           
+
+    TYPE(chem_emis_val_type), INTENT(INOUT), ALLOCATABLE, DIMENSION(:) ::  emt  !< variable to store emission input values, 
+                                                                                !< depending on the considered species
+
+    INTEGER,INTENT(IN) ::  nspec_out                                            !< Output of matching routine with number
+                                                                                !< of matched species
+
+    CHARACTER(LEN=80) ::  units                                                 !< Units of the emission data
+
+    INTEGER(iwp) ::  i                                                          !< running index for grid in x-direction
+    INTEGER(iwp) ::  j                                                          !< running index for grid in y-direction
+    INTEGER(iwp) ::  k                                                          !< running index for grid in z-direction
+    INTEGER(iwp) ::  m                                                          !< running index for horizontal surfaces
     
-    REAL(wp),ALLOCATABLE, DIMENSION(:)                                ::  time_factor !> factor for time scaling of emissions
-    REAL(wp),ALLOCATABLE, DIMENSION(:,:)                              ::  emis
-
-    REAL(wp), DIMENSION(24)                                           :: par_emis_time_factor      !< time factors 
-                                                                                      !  for the parameterized mode: these are fixed for each hour
-                                                                                      !  of a single day.
-    REAL(wp), DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr)                    ::  conv_to_ratio !> factor used for converting input 
-                                                                                        !  to adimensional concentration ratio
-
-   ! ------------------------------------------
-    ! variables for the conversion of indices i and j according to surface_mod
-
-    INTEGER(iwp)                                                      ::  i          !> running index for grid in x-direction
-    INTEGER(iwp)                                                      ::  j          !> running index for grid in y-direction
-    INTEGER(iwp)                                                      ::  k          !> running index for grid in z-direction
-    INTEGER(iwp)                                                      ::  m          !> running index for horizontal surfaces
-
-    REAL(wp), DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr)                    ::  tmp_temp
-
-    ! --- const -------------------------------
-    !-CONVERSION FACTORS: TIME
-    ! number of sec per hour = 3600   
-    REAL, PARAMETER   ::  s_per_hour = 3600.0  !  (s)/(hour)
-    ! number of sec per day = 86400   
-    REAL, PARAMETER   ::  s_per_day = 86400.0  !  (s)/(day)
-    ! number of hours in a year of 365 days:
-    REAL, PARAMETER   ::  hour_per_year = 8760.0 !> TBD: What about leap years?
-    ! number of hours in a day:
-    REAL, PARAMETER   ::  hour_per_day = 24.0
-
-    ! conversion from hours to seconds (s/hour) = 1/3600.0 ~ 0.2777778   
-    REAL, PARAMETER   ::  hour_to_s = 1/s_per_hour  !  (hour)/(s)
-    ! conversion from day to seconds (s/day) = 1/86400.0 ~ 1.157407e-05   
-    REAL, PARAMETER   ::  day_to_s = 1/s_per_day   !  (day)/(s)
-    ! conversion from year to sec (s/year) = 1/31536000.0 ~ 3.170979e-08   
-    REAL, PARAMETER   ::  year_to_s = 1/(s_per_hour*hour_per_year)  !  (year)/(s)
-
-    !-CONVERSION FACTORS: WEIGHT
-    !  Conversion from tons to kg (kg/tons) = 100.0/1 ~ 100
-    REAL, PARAMETER   ::  tons_to_kg = 100  !  (tons)/(kg)
-    !  Conversion from g to kg (kg/g) = 1/1000.0 ~ 0.001
-    REAL, PARAMETER   ::  g_to_kg = 0.001  !  (g)/(kg)
-    !  Conversion from g to kg (kg/g) = 1/1000.0 ~ 0.001
-    REAL, PARAMETER   ::  miug_to_kg = 0.000000001  !  (microng)/(kg)
-
-    !< CONVERSION FACTORS: fraction to ppm
-    REAL(wp), PARAMETER   ::  ratio2ppm  = 1.0e06_wp  
+    INTEGER(iwp) ::  icat                                                       !< Index for number of categories
+    INTEGER(iwp) ::  ispec                                                      !< index for number of species
+    INTEGER(iwp) ::  i_pm_comp                                                  !< index for number of PM components
+    INTEGER(iwp) ::  ivoc                                                       !< Index for number of VOCs
+    INTEGER(iwp) ::  time_index                                                 !< Index for time
+
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:) ::  delta_emis                        
+    REAL(wp), ALLOCATABLE, DIMENSION(:)   ::  time_factor                       !< factor for time scaling of emissions
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:) ::  emis
+
+    REAL(wp), DIMENSION(24) :: par_emis_time_factor                             !< time factors for the parameterized mode:
+                                                                               !< fixed houlry profile for example day
+    REAL(wp), DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr) ::  conv_to_ratio          !< factor used for converting input 
+                                                                                !< to concentration ratio
+    REAL(wp), DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr) ::  tmp_temp
+
+    !
+    !-- CONVERSION FACTORS: TIME  
+    REAL(wp), PARAMETER ::  s_per_hour = 3600.0                       !< number of sec per hour (s)/(hour)    
+    REAL(wp), PARAMETER ::  s_per_day = 86400.0                       !< number of sec per day (s)/(day)  
+    REAL(wp), PARAMETER ::  hour_per_year = 8760.0                    !< number of hours in a year of 365 days  
+    REAL(wp), PARAMETER ::  hour_per_day = 24.0                       !< number of hours in a day
+    
+    REAL(wp), PARAMETER ::  hour_to_s = 1/s_per_hour                  !< conversion from hours to seconds (s/hour) ~ 0.2777778      
+    REAL(wp), PARAMETER ::  day_to_s = 1/s_per_day                    !< conversion from day to seconds (s/day) ~ 1.157407e-05
+    REAL(wp), PARAMETER ::  year_to_s = 1/(s_per_hour*hour_per_year)  !< conversion from year to sec (s/year) ~ 3.170979e-08
+    !
+    !-- CONVERSION FACTORS: WEIGHT  
+    REAL(wp), PARAMETER ::  tons_to_kg = 100                          !< Conversion from tons to kg (kg/tons)    
+    REAL(wp), PARAMETER ::  g_to_kg = 0.001                           !< Conversion from g to kg (kg/g) 
+    REAL(wp), PARAMETER ::  miug_to_kg = 0.000000001                  !< Conversion from g to kg (kg/g)
+    !
+    !-- CONVERSION FACTORS: fraction to ppm
+    REAL(wp), PARAMETER ::  ratio2ppm  = 1.0e06  
     !------------------------------------------------------    
 
-    IF ( emission_output_required ) THEN
-
-    !>  Set emis_dt  !TBD: this is the same as dt_chem. We should consider the fact that dt_emis should be the timestep of input emissions or better defined, the timestep at which the emission routines are called: for now one hour. It should be made changeable.
-
+    IF ( emission_output_required )  THEN
+
+       !
+       !-- Set emis_dt  
        IF ( call_chem_at_all_substeps )  THEN
 
